## linuxcnc-ethercat 1.40.0.g8a607c0

=== Makefile ===
.PHONY: all configure install clean test docs

build: configure
	@$(MAKE) -C src all

all: build docs

clean:
	@$(MAKE) -C src -f Makefile.clean clean
	rm -f config.mk config.mk.tmp

test:
	@$(MAKE) -C src test

install: configure
	@$(MAKE) -C src install
	@$(MAKE) -C examples install-examples

configure: config.mk

config.mk: configure.mk
	@$(MAKE) -s -f configure.mk > config.mk.tmp
	@mv config.mk.tmp config.mk

docs: documentation/DEVICES.md

documentation/DEVICES.md: src/lcec_devices documentation/devices/*.yml
	(cd scripts; ./update-devicelist.sh)
	(cd scripts; ./update-devicetable.sh)

=== examples/Makefile ===
include ../config.mk

SUBDIRS = generic-complex swm-fm45a

install-examples:
	mkdir -p $(DESTDIR)$(EMC2_HOME)/share/linuxcnc-ethercat/examples
	cp -R $(SUBDIRS) $(DESTDIR)$(EMC2_HOME)/share/linuxcnc-ethercat/examples

=== src/Makefile ===
all: all-deps realtime user
.PHONY: all all-deps install install-user install-realtime user realtime all-tests test

-include ../config.mk
-include $(MODINC)
include Makefile.clean

#CC=g++

RTLDFLAGS += -Wl,-rpath,$(LIBDIR)
RTEXTRA_LDFLAGS += -Wl,--whole-archive liblcecdevices.a -Wl,--no-whole-archive -L$(LIBDIR) -llinuxcnchal -lethercat -lrt

#EXTRA_CFLAGS += --std=c2x
EXTRA_CFLAGS += -Wall # Increase debugging level
#EXTRA_CFLAGS += -fanalyzer # Use GCC's static analyzer tool, doubles compile time

## targets
lcec-common-objs := lcec_devicelist.o lcec_ethercat.o lcec_pins.o lcec_lookup.o lcec_modparam.o lcec_malloc.o
lcec-objs := lcec_main.o $(lcec-common-objs)
lcec-conf-srcs := $(wildcard lcec_conf*.c)
lcec-conf-objs = $(subst .c,.o,$(lcec-conf-srcs))
device-srcs := $(wildcard devices/*.c)
device-objs := $(subst .c,.o,$(device-srcs))
all-srcs := $(wildcard *.c devices/*.c tests/*.c)
all-deps := $(all-srcs:.c=.d)
all-tests-srcs := $(wildcard tests/test_*.c)
all-tests := $(all-tests-srcs:.c=.bin)

## target-specific variables

# override EXTRA_CFLAGS for lcec_conf's .c files
$(lcec-conf-objs): EXTRA_CFLAGS := $(filter-out -Wframe-larger-than=%,$(EXTRA_CFLAGS))


## build rules

# Automatically generate .d dependency files.  Mostly from GNU Make's docs.
#
# GCC Flags used:
#
#   -MT foo: explicitly set the dependency target name to 'foo'.
#        Without this, the target for 'devices/lcec_generic.o' would just
#        be 'lcec_generic.o', which breaks the makefile.
#   -MM: generate dependencies, but ignore system .h files
#   -MP: add a dummy rule for each .h that will keep make from throwing
#        errors if headers are deleted without 'make clean'.
%.d: %.c
	@set -e; rm -f $@; \
	$(CC) -MT $(subst .d,.o,$@) -MM -MP $(EXTRA_CFLAGS) $< > $@.$$$$; \
	sed 's,\($*\)\.o[ :]*,\1.o $@ : ,g' < $@.$$$$ > $@; \
	rm -f $@.$$$$

include $(all-srcs:.c=.d)
all-deps: $(all-deps)


liblcecdevices.a: $(device-objs)
	@$(ECHO) Creating library $@
	@$(Q)ar rcs liblcecdevices.a $(device-objs)


# Rules for building RTAI.  Currently disabled, and needs updated to
# work.  Ping @scottlaird if you need this and can't get it to work.
#
#ifeq ($(BUILDSYS),kbuild)
#
# dirty workaround to get the RTAI directory
#RTAIINCDIR = $(subst /rtai.h,,$(firstword $(wildcard $(foreach i,$(subst -I,,$(filter -I%,$(RTFLAGS))), $(i)/rtai.h))))
#ifneq ($(RTAIINCDIR),)
#  RTAIDIR = $(realpath $(RTAIINCDIR)/..)
#endif
#
#realtime:
#	$(MAKE) EXTRA_CFLAGS="$(EXTRA_CFLAGS)" KBUILD_EXTRA_SYMBOLS="$(RTLIBDIR)/Module.symvers $(RTAIDIR)/modules/ethercat/Module.symvers" -C $(KERNELDIR) SUBDIRS=`pwd` CC=$(CC) V=0 modules
#
#else

# This throws a warning about ignoring the old recipe for the target.
install: install-user install-realtime
	true  # override 'install' from $(MODINC)

realtime: lcec.so
user: lcec_conf lcec_devices lcec_configgen

# Run all tests (auto-generated above from tests/test_*.c).
test: $(all-tests)
	$(foreach var, $(all-tests), $(var);)

install-user: user
	mkdir -p $(DESTDIR)$(EMC2_HOME)/bin
	cp lcec_conf $(DESTDIR)$(EMC2_HOME)/bin/
	cp lcec_configgen $(DESTDIR)/usr/bin/

install-realtime: realtime
	mkdir -p $(DESTDIR)$(RTLIBDIR)/
	cp lcec.so $(DESTDIR)$(RTLIBDIR)/

lcec.so: lcec_main.o $(lcec-common-objs) liblcecdevices.a
	$(ECHO) Linking $@
	ld -d -r -o $@.tmp lcec_main.o $(lcec-common-objs)
	objcopy -j .rtapi_export -O binary $@.tmp $@.sym
	(echo '{ global : '; tr -s '\0' < $@.sym | xargs -r0 printf '%s;\n' | grep .; echo 'local : * ; };') > $@.ver
#$(CC) -shared -Bsymbolic $(RTLDFLAGS) -Wl,--version-script,$@.ver -o $@ lcec_main.o $(lcec-comon-objs) -lm
	$(CC) -shared -Bsymbolic $(RTLDFLAGS) -Wl,--version-script,$@.ver -o $@ lcec_main.o $(lcec-common-objs) -lm $(RTEXTRA_LDFLAGS)
	chmod -x $@

lcec_conf: $(lcec-conf-objs) $(lcec-common-objs) liblcecdevices.a
	$(CC) -o $@ $(lcec-conf-objs) $(lcec-common-objs) -Wl,-rpath,$(LIBDIR) -L$(LIBDIR) -llinuxcnchal -lexpat -Wl,--whole-archive liblcecdevices.a -Wl,--no-whole-archive -lethercat -lm

lcec_devices: lcec_devices.o $(lcec-common-objs) liblcecdevices.a
	$(CC) -o $@ lcec_devices.o $(lcec-common-objs) -Wl,-rpath,$(LIBDIR) -L$(LIBDIR) -llinuxcnchal -lexpat -Wl,--whole-archive liblcecdevices.a -Wl,--no-whole-archive -lethercat -lm

lcec_configgen: configgen/*.go configgen/*/*.go
	(cd configgen ; go build lcec_configgen.go)
	cp configgen/lcec_configgen .

configgen/devicelist: configgen/devicelist.go
	(cd configgen ; go build devicelist.go)

configgen/drivers/drivers.go: configgen/devicelist lcec_devices
	(cd configgen ; go generate)

# Rule for compiling tests/*.bin files.  We're naming test excutables *.bin so we can use wildcards in .gitignore and `make clean` to match them.
tests/%.bin: tests/%.o $(lcec-common-objs) liblcecdevices.a
	$(CC) -o $@ $(subst .bin,.o,$@) $(lcec-common-objs) -Wl,-rpath,$(LIBDIR) -L$(LIBDIR) -llinuxcnchal -lexpat -Wl,--whole-archive liblcecdevices.a -Wl,--no-whole-archive -lethercat -lm

=== debian/changelog ===
linuxcnc-ethercat (1.40.0.g8a607c0-0) unstable; urgency=low

  * Current HEAD: 0c872dd
  * Using Real Floats (#114)
  * Allow dynamic mapping of PDOS depending on Device-Config (#115)
  * added EL5002 and EL5032

 -- Bjarne von Horn <vh@igh.de>  Fri, 9 Nov 2023 16:53:00 +0100

linuxcnc-ethercat (0.9.5) unstable; urgency=low

  * better buffer handling of dynamic fsoe data
  * fixed el1918_logic pdo count calculation
  * added inverted inputs to EL1904
  * fixed el1918 to adapt new el6900 config method
  * Add Delta MS300
  * add additional AX5100 Types
  * removed txpdo state bit from el6900, due firmware change
  * Support added for EL9576
  * Adding Support for EK1101 and EL2652
  * Support added for EL9576
  * added support for EL1918 as TwinSAFE plc

 -- Sascha Ittner <sascha.ittner@modusoft.de>  Thu, 10 Mar 2022 09:13:50 +0100

linuxcnc-ethercat (0.9.4) unstable; urgency=low

  * added EL7211 debug pins
  * route digital input to HAL for EL7201-9014
  * added ramp function with at-speed pin to el7211/el7411 for use as spindle
  * Add support for all Omron G5 drives
  * added EP2809, EP2008, EK1120
  * added EL7411 (HALL velocity mode)
  * added EL7201-9014
  * added EL7031 and EL7041_0052 support
  * added EL1859
  * added EL2634
  * added EL3164
  * added EL1819
  * add SK1110 support
  * add linuxcnc 2.8 support
  * add 3lm2rm support
  * add el4134 support
  * moved from PI to BANG-BANG controller for task PLL.
  * add EL7221 support
  * added EL40x8 support
  * add support for EL2612
  * fixed fsoe command read data type
  * allow IP trsition on SDO initialization
  * added external encoder supoort for MDS5000
  * support for complete write on SDO init commads
  * added support for ax5203
  * add fsoe support
  * fixed a problem that could not read an unordered property
  * fix segfault during `lcec_update_slave_state_hal()` on Machinekit HAL
  * fixed el2521 sdo 8000:07 read size

 -- Sascha Ittner <sascha.ittner@modusoft.de>  Wed, 21 Jul 2021 11:47:50 +0200

linuxcnc-ethercat (0.9.3) unstable; urgency=low

  * NEW: support to sync master's task to the EC refclock (sittner)
      enabled via refSyncCycle="1", needs supplied patch against linuxcnc
  * NEW: support for EL2798 (frankbrossette)
  * NEW: support for EL41x4 (frankbrossette)
  * NEW: support for EL3255 5 Ch Potentiometer input device (sittner)
  * NEW: support EP2028 (sittner)
  * NEW: support for EL7211 (sittner)
  * NEW: support for AX5206 (sittner)
  * NEW: added SoE setup function for ethercat-config.xml (sittner)
  * NEW: added support to include external CoE/SoE init commands for ethercat-config.xml (sittner)
  * NEW: new module specific parameter support (narogon, sittner)
  * NEW: stmds5k, deasda, ax5206 and el7211 uses same encoder class for position feedback (sittner)
      ATTENTION: this may need some changes to existing configs, as some pins have changed
  * FIX: Fixed conceptual bug in intermediate config buffer handling (sittner)
  * FIX: sync refclock to masterclock now respects local jitter (sittner)
  * FIX: use master's synchronous ecrt_master_sdo_upload to read SDOs on init (sittner)
  * FIX: build script uses Makefile.modinc (sirop, sittner)
  * DEPRECATE: RTAI is not tested anymore (sittner)
  * CLEANUP: reworked pin export method (sittner)
  * CLEANUP: introduced function class concept (sittner)

 -- Sascha Ittner <sascha.ittner@modusoft.de>  Fri, 23 Mar 2018 14:38:41 +0200

linuxcnc-ethercat (0.9.2) unstable; urgency=low

  * added autoreset fault retry option for delta asda driver (sittner)
  * add driver support for EL2622 (koppi)
  * EL7342: fix counter underflow, counter overflow PDOs (koppi)
  * add device driver for EL7041-1000 (koppi)
  * fixed scale/offset config parsing (sittner)
  * GENERIC: support for complex pins (frankbrossette, sittner)
  * support for EL2202 and EL1252 added (claudiolorini)

 -- Sascha Ittner <sascha.ittner@modusoft.de>  Sun, 04 Oct 2015 21:51:14 +0200

linuxcnc-ethercat (0.9.1) unstable; urgency=low

  * Stoeber MDS5000 tourque calculation fixed
  * Support for simulation mode
  * Rework of build system

 -- Sascha Ittner <sascha.ittner@modusoft.de>  Wed, 11 Mar 2015 00:00:00 +0100

linuxcnc-ethercat (0.9.0-2) unstable; urgency=low

  * added example files

 -- Sascha Ittner <sascha.ittner@modusoft.de>  Tue, 28 Jan 2015 16:26:32 +0100

linuxcnc-ethercat (0.9.0-1) unstable; urgency=low

  * Initial release

 -- Sascha Ittner <sascha.ittner@modusoft.de>  Mon, 12 Jan 2015 10:19:04 +0100

=== debian/control ===
Source: linuxcnc-ethercat
Section: unknown
Priority: extra
Maintainer: Bjarne von Horn <vh@igh.de>
Build-Depends: debhelper (>= 8.0.0), libexpat1-dev, linuxcnc-dev | linuxcnc-sim-dev | linuxcnc-uspace-dev | machinekit-dev, etherlabmaster-dev | libethercat-dev, golang-go
Standards-Version: 3.9.3

Package: linuxcnc-ethercat
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, linuxcnc | linuxcnc-sim | linuxcnc-uspace | machinekit, etherlabmaster | ethercat-master
Description: LinuxCNC EtherCAT HAL driver
